import sys,time,argparse,math
from pythonosc import dispatcher
from pythonosc import osc_server

import logging
logging.basicConfig(level=logging.INFO)

sys.path.append('../')
from obswebsocket import obsws, requests  # noqa: E402

host = "localhost"
port = 4444
password = "the$hase"

ws = obsws(host, port, password)
ws.connect()

ScenesNames = []
SceneSources = []

def sourceSwitch(source_name,scene,switch):
    ws.call(requests.SetSceneItemProperties(source_name,scene,visible=switch)) 

def is_integer(v):
    try:
        int(v)
        return True;
    except ValueError:
        return False;

def scene_switch(unused_addr, args, oscValue):
	
    try:
        if (is_integer(oscValue)):
            print("CMD = '{0}' INDEX = {1} OBS SCENE NAME = '{2}'".format(args[0], oscValue, ScenesNames[int(oscValue)]))
            ws.call(requests.SetCurrentScene(ScenesNames[int(oscValue)]))
            # control sources by using sourceSwitch("source_Name","Scene_name", bool)
            # sourceSwitch("screen1","Scene1",False)
        else:
            print("OSC Value '{0}' cannot be converted to an integer.".format(oscValue))
    except:
        pass

if __name__ == "__main__":
    try:
        scenes = ws.call(requests.GetSceneList())

        for s in scenes.getScenes():
            name = s['name']
            print("Adding Scene = '{0}".format(name))
            ScenesNames.append(name)                        # Add every scene to a list of scenes

        print("CURRENT SCENES IN OBS:\n", ScenesNames)
       
        ### OSC SETTINGS
        parser = argparse.ArgumentParser()
        parser.add_argument("--ip", default="127.0.0.1", help="The ip to listen on")
        parser.add_argument("--port", type=int, default=5005, help="The port to listen on")

        args = parser.parse_args()                           # parser for --ip --port arguments
        dispatcher = dispatcher.Dispatcher()

        dispatcher.map("/Scene", scene_switch, "Scene")      # OSC LISTENER
        server = osc_server.ThreadingOSCUDPServer((args.ip, args.port), dispatcher)  
        print("Serving on {}".format(server.server_address))
        
        server.serve_forever()

    except KeyboardInterrupt:
        pass

    ws.disconnect()